#ifndef _IFVDES_H_
#define _IFVDES_H_ 1

/*	IFV.h
	Copyright Acquisition group, GANIL Caen, France

 	contents :  Description d'une carte IFV 
*/

/* Offsets des adresses de la carte */
#define IFVRFR	0x800	/* Lecture evenement en fifo, parametre random */
#define IFVRRR	0x0	/* Lecture evenement random , parametre random */
#define IFVRFF	0x1800	/* Lecture evenement en fifo, parametre en fifo */
#define IFVRRF	0x1000	/* Lecture evenement random , parametre en fifo */
#define IFVWBAS	0x2000	/* ecriture reg. de base pour lecture evt en random */
#define IFVCTRL	0x2800	/* ecriture mot de controle / lecture status */
/* Description  codes de commande (bits 12-8) du mot de controle */
/* Attention, lorsqu'on ecrit ces bits, on modifie aussi les bits 0 et 1 */
#define IFV_SO	0x300	/* shift-out evt */
#define IFV_RDIS 0x500	/* interdit mise en fifo des evts rejetes */
#define IFV_RENB 0x700	/* autorise mise en fifo des evts rejetes */
#define IFV_ZL1	 0x1100	/* mettre a zero sortie LEMO no 1 */
#define IFV_SL1	0x1900	/* mettre a +5V sortie LEMO no 1 */
#define IFV_ZL2 0x1300	/* mettre a zero sortie LEMO no 2 */
#define IFV_SL2 0x1B00	/* mettre a +5V sortie LEMO no 2 */
#define IFV_SL3 0x1500	/* mettre a +5V (80 ns) sortie LEMO no 3 */
/* Description  codes de commande (bits 1-0) du mot de controle */
#define IFV_RES	0x1	/* reset carte IFV */
#define IFV_IENB 0x2	/* autoriser interruptions face avant */
/* Description bits de status (en lecture) du mot de controle */
/* bits 23-16 contiennent nombre de places (nb evts) occupees dans la fifo */
#define IFV_INT	0x4	/* interruptions face avant autorisees */
#define IFV_VIDE 0x8	/* fifo vide */
#define IFV_PLEIN 0x10	/* fifo pleine */
#define IFV_L1	0x20	/* etat entree LEMO 1 */
#define IFV_L2	0x40	/* etat entree LEMO 2 */
#define IFV_RDY	0x80	/* ready */
/* Description des bits de status de l'evenement sur 1er mot de 16 bits de
   l'evenement contenant status + longueur */
#define IFVS_ACC 0x0400	/* evenement accepte */
#define IFVS_REJ 0x0800	/* evenement rejete */
#define IFVS_OVF 0x1000	/* evenement en overflow */
#define MSKSTIFV 0x1c00	/* masque pour extraire bits de status sur 16 bits */
#define MSKLGIFV 0x3ff   /* masque pour extraire longueur sur 16 bits */

#endif
