 /*	SERVCC:H  -- creation date :  oct 92
	Copyright Acquisition group, GANIL Caen, France
	author	: Luigi Martina

 	contents : Definition des structures de messages et des codes de 
		   commande pour les serveurs de commandes VXI,HTCAEN...
		   Dans le cas d'une attente de reponse, on reservera le code+1
		   pour la reponse.
		   Les codes 0 a 256 sont reserves a l'utilisateur
		   les codes superieurs a 256 sont reserves au systeme
*/




#ifndef	uchar
#define	uchar		unsigned char 
#endif


#ifndef ushort
#define	ushort		unsigned short
#endif

#define MAX_SVCC	5	/* nbre actuel de serveurs CC   */
#define LNAM_SERV      12	/* taille max du nom serveur    */

/* definitions des indices des differents serveurs */

#define N_HTCAEN	0	/* rang du serveur CAENET	*/
#define N_ECHEL		1	/* rang du serveur ECHELLES     */
#define N_SVXI 	        2	/* rang du serveur VXI          */
#define N_STEST         4	/* rang du serveur TEST         */
#define N_CAMAC		3	/* rang du serveur CAMAC        */

/* definitions de differents timeout emission & reception */

#define T_HTCAEN      2000l 
#define T_FHTCAEN     2000l
#define T_ECHEL       500l
#define T_SVXI        500l
#define T_CAMAC       500l
#define T_STEST       500l

/* Definition des noms des serveurs connus a ce joour */

#define HTCAEN        0x48544341l       /* ascii "HTCA" */
#define SCAMAC        0x5343414Dl	/* ascii "SCAM" */
#define ECHEL         0x45434845l	/* ascii "ECHE" */
#define STEST         0x53544553l       /* ascii "STES" */
#define SVXI          0x53565849l       /* ascii "SVXI" */
#define FHTCAEN       0x46485443l	/* ascii "FHTC" */
#define FECHEL        0x46454348l       /* ascii "FECH" */
         
#define SVCA_COD    10l		/* commande traitee par HTCAEN     */
                                /* pour l'instant code <> SVCC_COD */

#define SVCC_COD    20l         /* code pour serveurs standards    */
				/* VXI,CAMAC,STEST...              */

/* structure informations serveurs type CC */

typedef struct { 
			short first;
			char *cpuname;
			long taskname;
                        char *serv_name;
                        char *alias;
			long time_snd;
                        long time_rep;
			long free[3];
		} INFO_SVCC;

/* structure bloc acquittement memoire messages longs  (26 octets) */

typedef struct  {
	   long taille;		/* taille du bloc data 		*/
	   long *vme_base;      /* @ base memoire vue du VME    */
           char *mem_addr;	/* @ bloc memoire locale Cpu    */
	   char *phyev_addr;	/* @ locale phys a positionner  */
           ushort phyev_bitnum;	/* 0x00 a 0x07 pour bit clear de 0 a 7 */
				/* 0x80 a 0x87 pour bit set de 0 a 7 */
           ushort cpunum;       /* no du cpu qui envoi le message     */
	   short  *err_addr; 	/* @ coderr rendu par emetteur    */ 
           short  free[2];
		} DESC_INFO;


/* definition structure du code de commande */

typedef struct {
                 ushort parm : 4;	/* type bloc parametres commande   */
		 ushort free : 4;	/* bloc de libre */
		 ushort protocol : 4;   /* type de protocole voir tserv:h  */
		 ushort typ_serv : 4;   /* type de serveur HT,ECH,JBUS ... */
               } COD_CC;

/* definition de la structure dmande de message long (48 octets max) */

typedef struct  {
	   	   union   {
	   			ushort codecmd;
				ushort coderep;
				COD_CC cod_svcc;
		   	   } Cod;
                   short  coderr;
                   union   {
                             DESC_INFO   mem_info;
		             char        buf[40];
                           } Parm; 
                   short taille;
		   short free;
                }  LSVCC_MSG;

#define LMSG_MAX   		40l	/* taille max du message utile */
#define LBUF_MAX              0xffff     /* taille max pour le malloc   */

/* definition des types de protocoles utilises */

#define LONG            2       /* protocole LONG , memoire chez emetteur */
#define STANDARD        1	/* protcole messages courts 40 octet max  */
#define LNGNULL         3       /* protocole NULL memoire chez receiver   */  

/* definitions relatives aux phys events */

#define SET_2			0x82
#define CLR_2			0x02
#define PE_DELAY                2000l
