#ifndef vmecom_INC__
#define vmecom_INC__ 1

/***************************************************
*                                                  *
*     FICHIER DES DEFINITIONS DES STRUCTURES	   *
*     ET DES CONSTANTES UTILES POUR LE DIALOGUE    *
*     AVEC LE VME SOUS TCP/IP                      *
*                                                  *
*     Auteur :MARCHAND                             *
*                                                  *
*     Date :21/8/90                                *
*                                                  *
*     Modifications:                               *
*                                                  *
*                                                  *
*       B. Raine le 7 sep 94 pour utilisation      *
*         de la nouvelle librairie TCP/IP GANIL    *
*                                                  *
*                                                  *
        B. Raine le 27 mai 98
	   Passage sous unix, 
	     => redifinition des codes erreur 
****************************************************/
#include "gen_type.h" /* definition generale des tyes */

#define LINKVME "LINKVME"	/* Nom logique du noeud destinataire, 
                                   utilise uniquement par cvme */

#define PORTVME 3000		/* Port destination du serveur VME */

#ifdef __vms
#define LOGTABLE "LNM$PROCESS_TABLE"	/* Table des noms logiques utilise pour
					   la traduction */
#endif

#define MAGIQUE 27182818	/* Identificateur de message pour le VME */

#define COD_OK  	0	/* Code de reception d'un message sans erreur*/
#define COD_INFO	1       /* Code info */
#define COD_WARNING	2	/* Code warning */
#define COD_ERROR	3	/* Code erreur */

/* Valeurs par defaut des variables de communication */

#define DEF_VMECOM_OPEN_TIMEOUT 5  /* open timeout 1 sec = 5 * 200 ms */
#define DEF_VMECOM_READ_TIMEOUT 50 /* read timeout 10 sec = 50 * 200 ms */
#define DEF_VMECOM_WRITE_TIMEOUT 5 /* write timeout 1 sec = 5 * 200 ms */


/* Donnees pour un message de surveillance */
 
#define MAXCPU	6		/* Nombre max de cpu traites */

/* Structure de donnees des cpu pour le message Vme */

typedef struct{
	INT32 status;    /* Status de l'application */
	char valide;	/* Flag indiquant que la tache sur le cpu tourne */
	char appltyp;   /* Type d'application executee sur le cpu */
	char cpuname[8];/* Nom du cpu */
	}CPUDATA;

/* Message de donnees VME pour le surveilleur */

typedef struct{
	INT32 errcpt;    /* Compteur d'erreur */
	INT32 evcpt;	/* Compteur d'evenement */
	INT32 nb0;	/* Nb d'evenement/s*100 depuis le dernier releve */
        INT32 global_status;
	INT32 errtype;	/* Type de message cpu */

	CPUDATA cpu[MAXCPU];/* Donnees des cpu */

	char nbcpu;	/* Nombre de cpu traites */

	char ficname[40];	/* Nom du fichier application */
	char errcpu[5];		/* Nom du cpu envoyant l'erreur */
	char errtask[5];	/* Nom de la tache correspondante */
	char receive[50];	/* Message du cpu */

	char aligne;		/* Pour alignement sur un nb pair d'octets */
		
	}VMEDATA;

/* Structure de l'entete des messages */

typedef struct{
	INT32 ident;     /* mot de synchro	*/
	INT32 noeud;	/* Noeud expediteur */
	INT32 process;	/* Pid  expediteur */
	INT32 code;	/* Code commande */
	INT32 reserve;
	INT32 taille;	/* Taille de message suivant */
	}ENTETE;

/* Inclure les definitions d'utilisation du package */

#include "vmecom_def.h"


#endif
