/**********************************************************/
/*                                                        */
/*                   Package Hermes                       */
/*                                                        */
/* Hermes.h                                               */
/*                                                        */
/* Copyright GANIL, Groupe Informatique Physique, 1999    */
/*                                                        */
/* Auteur : Frederic Saillant                             */
/*                                                        */
/* Version : v1r1 (EXOGAM)                                */
/*                                                        */
/* Date de creation : 14 mai 1999                         */
/*                                                        */
/* Derniere mise a jour : 1er juin 1999                   */
/*                                                        */
/* Fichier header de la bibliotheque Hermes, contenant    */
/* les prototypes ANSI des fonctions exportees de Hermes  */
/*                                                        */
/**********************************************************/

#ifndef _Hermes_H_
#define _Hermes_H_

/* Definition de GR_OK : code de retour OK, valeur 0 */
#ifdef GR_OK
#undef GR_OK
#endif
#define GR_OK 0

/* Flags de severite d'un message d'erreur */
#define HERMES_DEBUG       0x01
#define HERMES_INFO        0x02
#define HERMES_WARNING     0x04
#define HERMES_ERROR       0x08
#define HERMES_FATAL       0x10
#define HERMES_ALARM       0x20
#define HERMES_FAULT       0x40
#define HERMES_FAILURE     0x80
#define HERMES_CATASTROPHE 0x100

#define HERMES_SEND    1
#define HERMES_NO_SEND 0

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _ErrSend_
extern
#endif
int HermesInit ( char * AppName, int Send );

#ifndef _ErrSend_
extern
#endif
int ErrSend ( int ErrCode, int ErrType, char * Source, char * ExtraInfo );

#ifndef _ErrSend_
extern
#endif
int ErrGet ( int ErrCode, char * Buffer, int BufSize );

#ifdef __cplusplus
}
#endif

#endif
