
/*	ServMsgDes.h -- creation date : 23 mars 1998 last update : 25 mai 1998
	Copyright Acquisition group, GANIL Caen, France
	author	: Bruno RAINE


 	contents : definitions structures echangees entre clients et serveurs

*/




/*
      Modes Acces Aux Serveur 

  - prendre semaphore acces queue de messages 	
  - ouvrir la queue de message
  - deposer message
  - fermer la queue
  - liberer semaphore
 
*/


/* definition structure Entete Message a un Serveur */

typedef struct {
        int  Code;
        char ServName[LNAM_SERV];

	int MessTotalNumber;     /* nbre total de messages */
	int MessTotalSize;

        int MessCourNum;	/* no du message courant  */
        int MessCourSize;	/* taille message courant */
        int CodeRetSvcc;        /* Code de retour pour protocol svcc */
        int free[2];
} SERV_ENTETE_MESSAGE;	



typedef struct Message{

        SERV_ENTETE_MESSAGE Entete;
        char Buf[MSGQ_SIZE - sizeof(SERV_ENTETE_MESSAGE)];
} SERV_MESSAGE;
  



#define SERV_MSG_SIZE (MSGQ_SIZE - sizeof(SERV_ENTETE_MESSAGE))


/* definition des structures Serveur mises en liste */
typedef struct {
       		char 	ServName[LNAM_SERV];
  		int  	Ptid;
		mqd_t 	MqId;
		sem_t	*MqSemId;
		int	SigNum;
		int 	SigVal;
		int	Prio;
		int 	MessMaxNum;
	 	int     MessSize;
		int     free[5];
	       } SERV_ID;

typedef struct {
 		SERV_ID ServId;		
		LISTE	Route;
                LISTE   ListMsg;
		int  free[5];       
	       } LIST_SERV_ID;



/* definition structure messages mises en liste */
typedef struct {
		SERV_ID ServId;			/* ServId du destinataire */
		int	MessLen;		/* longueur du message */
		char 	*Mess;			/* pointeur message utilisateur */
 		int     Timeout;
                int     CodeRetSvcc;
                int     free[5];
               } LIST_MSG_ID;



/* definitions des protos des fonctions utilisees */

int MsgReceive(SERV_MESSAGE *ServMessage,
				    char **Buf, int *Len, int Timeout);

int MsgSendByName(char *ServName, char *Buf, int Size,int Timeout);


int MsgGet(SERV_MESSAGE *ServMessage,
				    char **Buf, int *Len, int Timeout);

int MsgAnsw(SERV_MESSAGE *ServMessage,
				     char *Buf, int Size, int Timeout);

int SigQueue(char *ServName, int SigNum, int SigVal);

int MsgTrySend(int *NbMsg);
